Index: trunk/src/VBox/Runtime/Makefile.kmk
===================================================================
--- trunk/src/VBox/Runtime/Makefile.kmk	(revision 63450)
+++ trunk/src/VBox/Runtime/Makefile.kmk	(revision 63451)
@@ -267,5 +267,6 @@
  	RT_NO_GIP \
 	RT_WITHOUT_NOCRT_WRAPPERS \
-       IPRT_WITH_OPENSSL
+       IPRT_WITH_OPENSSL \
+       NOFILEID
 #RuntimeR3_DEFS         += RTMEM_WRAP_TO_EF_APIS
 ifdef IPRT_WITH_KSTUFF
@@ -1829,5 +1830,5 @@
 #
 RuntimeR0_TEMPLATE      = VBoxR0
-RuntimeR0_DEFS          = IN_RT_R0 RT_WITH_VBOX
+RuntimeR0_DEFS          = IN_RT_R0 RT_WITH_VBOX NOFILEID
 ifn1of ($(KBUILD_TARGET_ARCH), amd64 x86)
  RuntimeR0_DEFS        += RT_NO_GIP
@@ -1976,5 +1977,5 @@
 RuntimeR0Drv_TEMPLATE   = VBoxR0DrvLib
 RuntimeR0Drv_SDKS.win   = ReorderCompilerIncs $(VBOX_WINDDK) $(VBOX_WINPSDK)INCS VBOX_OPENSSL
-RuntimeR0Drv_DEFS       = IN_RT_R0 RT_WITH_VBOX RT_WITHOUT_NOCRT_WRAPPERS RT_NO_EXPORT_SYMBOL
+RuntimeR0Drv_DEFS       = IN_RT_R0 RT_WITH_VBOX RT_WITHOUT_NOCRT_WRAPPERS RT_NO_EXPORT_SYMBOL NOFILEID
 RuntimeR0Drv_DEFS.win   = IN_SUP_R0 LDR_ONLY_PE
 RuntimeR0Drv_DEFS.linux = MODULE KBUILD_MODNAME=KBUILD_STR\(vboxdrv\) KBUILD_BASENAME=KBUILD_STR\(vboxdrv\) IN_SUP_R0
@@ -2544,5 +2545,5 @@
  #
  RuntimeRC_TEMPLATE      = VBoxRc
- RuntimeRC_DEFS          = IN_RT_RC RT_WITH_VBOX IN_SUP_RC IN_VMM_RC
+ RuntimeRC_DEFS          = IN_RT_RC RT_WITH_VBOX IN_SUP_RC IN_VMM_RC NOFILEID
  RuntimeRC_INCS          = include
  RuntimeRC_SOURCES      := \
Index: trunk/src/VBox/Runtime/common/asn1/asn1-cursor.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/asn1/asn1-cursor.cpp	(revision 63450)
+++ trunk/src/VBox/Runtime/common/asn1/asn1-cursor.cpp	(revision 63451)
@@ -56,10 +56,4 @@
 # define RTASN1_MAX_NESTING     32
 #endif
-
-
-/*********************************************************************************************************************************
-*   Global Variables                                                                                                             *
-*********************************************************************************************************************************/
-static char const g_achDigits[11] = "0123456789";
 
 
Index: trunk/src/VBox/Runtime/common/asn1/asn1-ut-string.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/asn1/asn1-ut-string.cpp	(revision 63450)
+++ trunk/src/VBox/Runtime/common/asn1/asn1-ut-string.cpp	(revision 63451)
@@ -207,4 +207,5 @@
 
 
+#if 0 /* unused */
 /** GL mappings for ISO-IR-87 (Japanese),  with space and delete. */
 static const RTISO2022MAP g_IsoIr87Map =
@@ -217,4 +218,5 @@
     { 0x24, 0x2b, 0x42, 0xff, 0xff, 0xff } /* Esc into G3 */,
 };
+#endif
 
 
Index: trunk/src/VBox/Runtime/common/crypto/store-cert-add-basic.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/crypto/store-cert-add-basic.cpp	(revision 63450)
+++ trunk/src/VBox/Runtime/common/crypto/store-cert-add-basic.cpp	(revision 63451)
@@ -82,4 +82,5 @@
 
 
+#ifdef RT_STRICT
 /**
  * Checks if we've found all the certificates already.
@@ -96,4 +97,5 @@
     return true;
 }
+#endif /* RT_STRICT */
 
 
Index: trunk/src/VBox/Runtime/common/math/bignum.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/math/bignum.cpp	(revision 63450)
+++ trunk/src/VBox/Runtime/common/math/bignum.cpp	(revision 63451)
@@ -177,4 +177,5 @@
 
 
+#if !defined(IPRT_BIGINT_WITH_ASM) || defined(RT_STRICT)
 /**
  * Does addition with borrow.
@@ -197,4 +198,5 @@
     return uRet;
 }
+#endif
 
 /** @} */
@@ -282,4 +284,5 @@
 }
 
+#if 0 /* unused */
 DECLINLINE(void) rtBigNumElement2xAdd1x(RTBIGNUMELEMENT2X *puValue, RTBIGNUMELEMENT uAdd)
 {
@@ -290,4 +293,5 @@
 #endif
 }
+#endif /* unused */
 
 /** @} */
@@ -1615,4 +1619,5 @@
 
 
+#if 0 /* unused */
 /**
  * Clears a bit in the magnitude of @a pBigNum.
@@ -1634,4 +1639,5 @@
     }
 }
+#endif /* unused */
 
 
@@ -1659,4 +1665,5 @@
 
 
+#if 0 /* unused */
 /**
  * Writes a bit in the magnitude of @a pBigNum.
@@ -1676,4 +1683,5 @@
     return VINF_SUCCESS;
 }
+#endif
 
 
Index: trunk/src/VBox/Runtime/common/misc/lockvalidator.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/misc/lockvalidator.cpp	(revision 63450)
+++ trunk/src/VBox/Runtime/common/misc/lockvalidator.cpp	(revision 63451)
@@ -1569,4 +1569,5 @@
 
 
+#if 0 /* unused */
 /**
  * Gets the lock name for the given record.
@@ -1606,6 +1607,8 @@
     }
 }
-
-
+#endif /* unused */
+
+
+#if 0 /* unused */
 /**
  * Gets the class for this locking record.
@@ -1665,5 +1668,5 @@
     }
 }
-
+#endif /* unused */
 
 /**
Index: trunk/src/VBox/Runtime/generic/RTSystemShutdown-generic.cpp
===================================================================
--- trunk/src/VBox/Runtime/generic/RTSystemShutdown-generic.cpp	(revision 63450)
+++ trunk/src/VBox/Runtime/generic/RTSystemShutdown-generic.cpp	(revision 63451)
@@ -38,4 +38,5 @@
 RTDECL(int) RTSystemShutdown(RTMSINTERVAL cMsDelay, uint32_t fFlags, const char *pszLogMsg)
 {
+    RT_NOREF(cMsDelay, pszLogMsg);
     AssertPtrReturn(pszLogMsg, VERR_INVALID_POINTER);
     AssertReturn(!(fFlags & ~RTSYSTEM_SHUTDOWN_VALID_MASK), VERR_INVALID_PARAMETER);
Index: trunk/src/VBox/Runtime/generic/http-curl.cpp
===================================================================
--- trunk/src/VBox/Runtime/generic/http-curl.cpp	(revision 63450)
+++ trunk/src/VBox/Runtime/generic/http-curl.cpp	(revision 63451)
@@ -980,9 +980,8 @@
  *
  * @returns Array of proxy configs (CFProxySupport.h style).
- * @param   pThis           The HTTP client instance.
  * @param   hUrlTarget      The URL we're about to use.
  * @param   hUrlScript      The PAC script URL.
  */
-static CFArrayRef rtHttpDarwinExecuteProxyAutoConfigurationUrl(PRTHTTPINTERNAL pThis, CFURLRef hUrlTarget, CFURLRef hUrlScript)
+static CFArrayRef rtHttpDarwinExecuteProxyAutoConfigurationUrl(CFURLRef hUrlTarget, CFURLRef hUrlScript)
 {
     char szTmp[256];
@@ -1070,5 +1069,5 @@
 
         int rcRet = VINF_NOT_SUPPORTED;
-        CFArrayRef hArray = rtHttpDarwinExecuteProxyAutoConfigurationUrl(pThis, hUrlTarget, hUrlScript);
+        CFArrayRef hArray = rtHttpDarwinExecuteProxyAutoConfigurationUrl(hUrlTarget, hUrlScript);
         if (hArray)
         {
@@ -1180,5 +1179,5 @@
  */
 static int rtHttpDarwinConfigureProxyForUrlWorker(PRTHTTPINTERNAL pThis, CFDictionaryRef hDictProxies,
-                                                  const char *pszUrl, PRTURIPARSED pParsed, const char *pszHost)
+                                                  const char *pszUrl, const char *pszHost)
 {
     CFArrayRef  hArray;
@@ -1259,5 +1258,5 @@
                             CFRelease(hArray);
 
-                        hArray = rtHttpDarwinExecuteProxyAutoConfigurationUrl(pThis, hUrlTarget, hUrlScript);
+                        hArray = rtHttpDarwinExecuteProxyAutoConfigurationUrl(hUrlTarget, hUrlScript);
                         if (hArray)
                         {
@@ -1334,5 +1333,5 @@
     CFDictionaryRef hDictProxies = CFNetworkCopySystemProxySettings(); /* Alt for 10.5: SCDynamicStoreCopyProxies(NULL); */
     if (hDictProxies)
-        rc = rtHttpDarwinConfigureProxyForUrlWorker(pThis, hDictProxies, pszUrl, &Parsed, pszHost);
+        rc = rtHttpDarwinConfigureProxyForUrlWorker(pThis, hDictProxies, pszUrl, pszHost);
     else
         rc = VINF_NOT_SUPPORTED;
Index: trunk/src/VBox/Runtime/r0drv/darwin/alloc-r0drv-darwin.cpp
===================================================================
--- trunk/src/VBox/Runtime/r0drv/darwin/alloc-r0drv-darwin.cpp	(revision 63450)
+++ trunk/src/VBox/Runtime/r0drv/darwin/alloc-r0drv-darwin.cpp	(revision 63451)
@@ -29,4 +29,5 @@
 *   Header Files                                                                                                                 *
 *********************************************************************************************************************************/
+#pragma GCC diagnostic ignored "-Wdeprecated-declarations" /* (IOMallocContiguous et al are deprecated) */
 #include "the-darwin-kernel.h"
 #include "internal/iprt.h"
Index: trunk/src/VBox/Runtime/r0drv/darwin/dbgkrnlinfo-r0drv-darwin.cpp
===================================================================
--- trunk/src/VBox/Runtime/r0drv/darwin/dbgkrnlinfo-r0drv-darwin.cpp	(revision 63450)
+++ trunk/src/VBox/Runtime/r0drv/darwin/dbgkrnlinfo-r0drv-darwin.cpp	(revision 63451)
@@ -771,5 +771,4 @@
                 /* Validate the sections. */
                 uint32_t            uAlignment = 0;
-                uintptr_t           uAddr      = pSeg->vmaddr;
                 MY_SECTION const   *paSects    = (MY_SECTION const *)(pSeg + 1);
                 for (uint32_t i = 0; i < pSeg->nsects; i++)
@@ -1167,7 +1166,8 @@
     AssertPtrReturn(pThis, VERR_INVALID_HANDLE);
     AssertMsgReturn(pThis->u32Magic == RTDBGKRNLINFO_MAGIC, ("%p: u32Magic=%RX32\n", pThis, pThis->u32Magic), VERR_INVALID_HANDLE);
-    AssertPtrReturn(pszMember, VERR_INVALID_PARAMETER);
-    AssertPtrReturn(pszStructure, VERR_INVALID_PARAMETER);
-    AssertPtrReturn(poffMember, VERR_INVALID_PARAMETER);
+    AssertPtrReturn(pszMember, VERR_INVALID_POINTER);
+    AssertPtrReturn(pszModule, VERR_INVALID_POINTER);
+    AssertPtrReturn(pszStructure, VERR_INVALID_POINTER);
+    AssertPtrReturn(poffMember, VERR_INVALID_POINTER);
     return VERR_NOT_FOUND;
 }
Index: trunk/src/VBox/Runtime/r3/darwin/mp-darwin.cpp
===================================================================
--- trunk/src/VBox/Runtime/r3/darwin/mp-darwin.cpp	(revision 63450)
+++ trunk/src/VBox/Runtime/r3/darwin/mp-darwin.cpp	(revision 63451)
@@ -78,4 +78,6 @@
 }
 
+
+#if 0 /* unused */
 /**
  * Internal worker that determines the current number of logical CPUs (hyperthreads).
@@ -93,4 +95,6 @@
     return 1;
 }
+#endif /* unused */
+
 
 /**
Index: trunk/src/VBox/Runtime/r3/generic/allocex-r3-generic.cpp
===================================================================
--- trunk/src/VBox/Runtime/r3/generic/allocex-r3-generic.cpp	(revision 63450)
+++ trunk/src/VBox/Runtime/r3/generic/allocex-r3-generic.cpp	(revision 63451)
@@ -41,4 +41,5 @@
 DECLHIDDEN(int) rtMemAllocEx16BitReach(size_t cbAlloc, uint32_t fFlags, void **ppv)
 {
+    RT_NOREF(cbAlloc, fFlags, ppv);
     return VERR_NOT_SUPPORTED;
 }
@@ -47,4 +48,5 @@
 DECLHIDDEN(int) rtMemAllocEx32BitReach(size_t cbAlloc, uint32_t fFlags, void **ppv)
 {
+    RT_NOREF(cbAlloc, fFlags, ppv);
     return VERR_NOT_SUPPORTED;
 }
@@ -53,4 +55,5 @@
 DECLHIDDEN(void) rtMemFreeExYyBitReach(void *pv, size_t cb, uint32_t fFlags)
 {
+    RT_NOREF(pv, cb, fFlags);
     AssertFailed();
 }
Index: trunk/src/VBox/Runtime/testcase/tstRTDarwinMachKernel.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTDarwinMachKernel.cpp	(revision 63450)
+++ trunk/src/VBox/Runtime/testcase/tstRTDarwinMachKernel.cpp	(revision 63451)
@@ -66,5 +66,5 @@
 
 
-int main(int argc, char **argv)
+int main()
 {
     RTTEST hTest;
Index: trunk/src/VBox/Runtime/testcase/tstRTR0DbgKrnlInfo.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTR0DbgKrnlInfo.cpp	(revision 63450)
+++ trunk/src/VBox/Runtime/testcase/tstRTR0DbgKrnlInfo.cpp	(revision 63451)
@@ -94,9 +94,8 @@
             RTR0TESTR0_CHECK_RC_BREAK(RTR0DbgKrnlInfoQuerySymbol(hKrnlInfo, NULL, NULL, &pvSymbol), VERR_INVALID_PARAMETER);
 
-            RTDBGKRNLINFO hTmp = hKrnlInfo;
+            RTR0DbgKrnlInfoRelease(hKrnlInfo);
             hKrnlInfo = NIL_RTDBGKRNLINFO;
-            RTR0DbgKrnlInfoRelease(hKrnlInfo);
             uint32_t cRefs;
-            RTR0TESTR0_CHECK_MSG((cRefs = RTR0DbgKrnlInfoRelease(hKrnlInfo)) == 0, ("cRefs=%#x", cRefs));
+            RTR0TESTR0_CHECK_MSG((cRefs = RTR0DbgKrnlInfoRelease(NIL_RTDBGKRNLINFO)) == 0, ("cRefs=%#x", cRefs));
             break;
         }
Index: trunk/src/VBox/Runtime/testcase/tstRTR0DbgKrnlInfoDriver.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTR0DbgKrnlInfoDriver.cpp	(revision 63450)
+++ trunk/src/VBox/Runtime/testcase/tstRTR0DbgKrnlInfoDriver.cpp	(revision 63451)
@@ -48,4 +48,5 @@
 extern "C" DECLEXPORT(int) TrustedMain(int argc, char **argv, char **envp)
 {
+    RT_NOREF(argc, argv, envp);
 #ifndef VBOX
     RTPrintf("tstSup: SKIPPED\n");
Index: trunk/src/VBox/Runtime/testcase/tstVector.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstVector.cpp	(revision 63450)
+++ trunk/src/VBox/Runtime/testcase/tstVector.cpp	(revision 63451)
@@ -57,4 +57,7 @@
 
 /* Start by instantiating each function once for syntax checking */
+#ifdef __clang__
+# pragma GCC diagnostic ignored "-Wunused-function" /* https://llvm.org/bugs/show_bug.cgi?id=22712 */
+#endif
 RTVEC_DECL_STRUCT(tstInstance, void *)
 RTVEC_DECL_STRUCT(tstInstance2, void *)
@@ -69,9 +72,7 @@
 RTVEC_DECLFN_PUSHBACK(tstInstance, void *)
 RTVEC_DECLFN_POPBACK(tstInstance)
-RTVEC_DECLFN_POPBACK_DELETE(tstInstance2, void *, deletePVoid,
-                            tstInstanceDeleteAdapterId)
+RTVEC_DECLFN_POPBACK_DELETE(tstInstance2, void *, deletePVoid, tstInstanceDeleteAdapterId)
 RTVEC_DECLFN_CLEAR(tstInstance)
-RTVEC_DECLFN_CLEAR_DELETE(tstInstance2, deletePVoid,
-                          tstInstanceDeleteAdapterId)
+RTVEC_DECLFN_CLEAR_DELETE(tstInstance2, deletePVoid, tstInstanceDeleteAdapterId)
 RTVEC_DECLFN_DETACH(tstInstance, void *)
 