Index: /trunk/include/iprt/types.h
===================================================================
--- /trunk/include/iprt/types.h	(revision 63548)
+++ /trunk/include/iprt/types.h	(revision 63549)
@@ -251,5 +251,5 @@
       */
 #    undef bool
-     typedef _Bool bool; 
+     typedef _Bool bool;
 #   endif
 #  else
Index: /trunk/include/iprt/win/iphlpapi.h
===================================================================
--- /trunk/include/iprt/win/iphlpapi.h	(revision 63548)
+++ /trunk/include/iprt/win/iphlpapi.h	(revision 63549)
@@ -37,3 +37,2 @@
 #endif
 
-
Index: /trunk/include/iprt/win/objidl.h
===================================================================
--- /trunk/include/iprt/win/objidl.h	(revision 63548)
+++ /trunk/include/iprt/win/objidl.h	(revision 63549)
@@ -37,3 +37,2 @@
 #endif
 
-
Index: /trunk/include/iprt/win/setupapi.h
===================================================================
--- /trunk/include/iprt/win/setupapi.h	(revision 63548)
+++ /trunk/include/iprt/win/setupapi.h	(revision 63549)
@@ -37,3 +37,2 @@
 #endif
 
-
Index: /trunk/include/iprt/win/shlwapi.h
===================================================================
--- /trunk/include/iprt/win/shlwapi.h	(revision 63548)
+++ /trunk/include/iprt/win/shlwapi.h	(revision 63549)
@@ -37,4 +37,2 @@
 #endif
 
-
-
Index: /trunk/include/iprt/win/ws2tcpip.h
===================================================================
--- /trunk/include/iprt/win/ws2tcpip.h	(revision 63548)
+++ /trunk/include/iprt/win/ws2tcpip.h	(revision 63549)
@@ -37,4 +37,2 @@
 #endif
 
-
-
Index: /trunk/src/VBox/Additions/WINNT/Graphics/Video/mp/xpdm/VBoxMPDriver.cpp
===================================================================
--- /trunk/src/VBox/Additions/WINNT/Graphics/Video/mp/xpdm/VBoxMPDriver.cpp	(revision 63548)
+++ /trunk/src/VBox/Additions/WINNT/Graphics/Video/mp/xpdm/VBoxMPDriver.cpp	(revision 63549)
@@ -15,4 +15,5 @@
  * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
+
 
 /*********************************************************************************************************************************
Index: /trunk/src/VBox/Additions/WINNT/Installer/RegCleanup.cpp
===================================================================
--- /trunk/src/VBox/Additions/WINNT/Installer/RegCleanup.cpp	(revision 63548)
+++ /trunk/src/VBox/Additions/WINNT/Installer/RegCleanup.cpp	(revision 63549)
@@ -28,4 +28,5 @@
  There seems to be a subtle problem with the VirtualBox util.
  */
+
 
 /*********************************************************************************************************************************
Index: /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDispIf.cpp
===================================================================
--- /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDispIf.cpp	(revision 63548)
+++ /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDispIf.cpp	(revision 63549)
@@ -23,4 +23,5 @@
 
 #include <malloc.h>
+
 
 /*********************************************************************************************************************************
Index: /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxIPC.cpp
===================================================================
--- /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxIPC.cpp	(revision 63548)
+++ /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxIPC.cpp	(revision 63549)
@@ -17,4 +17,5 @@
  * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
+
 
 /*********************************************************************************************************************************
Index: /trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuest-netbsd.c
===================================================================
--- /trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuest-netbsd.c	(revision 63548)
+++ /trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuest-netbsd.c	(revision 63549)
@@ -106,4 +106,5 @@
 
 #define VBOXGUEST_STATE_INITOK 1 << 0
+
 
 /*********************************************************************************************************************************
@@ -652,5 +653,5 @@
 
             error = devsw_attach("vboxguest", NULL, &bmajor, &g_VBoxGuestNetBSDChrDevSW, &cmajor);
-                
+
             if (error == EEXIST)
                 error = 0; /* maybe built-in ... improve eventually */
Index: /trunk/src/VBox/Devices/Audio/DrvHostCoreAudio.cpp
===================================================================
--- /trunk/src/VBox/Devices/Audio/DrvHostCoreAudio.cpp	(revision 63548)
+++ /trunk/src/VBox/Devices/Audio/DrvHostCoreAudio.cpp	(revision 63549)
@@ -15,4 +15,5 @@
  * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
+
 
 /*********************************************************************************************************************************
Index: /trunk/src/VBox/Devices/Audio/DrvHostNullAudio.cpp
===================================================================
--- /trunk/src/VBox/Devices/Audio/DrvHostNullAudio.cpp	(revision 63548)
+++ /trunk/src/VBox/Devices/Audio/DrvHostNullAudio.cpp	(revision 63549)
@@ -41,4 +41,5 @@
  * THE SOFTWARE.
  */
+
 
 /*********************************************************************************************************************************
Index: /trunk/src/VBox/Devices/Graphics/DevVGA_VDMA.cpp
===================================================================
--- /trunk/src/VBox/Devices/Graphics/DevVGA_VDMA.cpp	(revision 63548)
+++ /trunk/src/VBox/Devices/Graphics/DevVGA_VDMA.cpp	(revision 63549)
@@ -44,4 +44,5 @@
 # include <iprt/memcache.h>
 #endif
+
 
 /*********************************************************************************************************************************
Index: /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/drv/VBoxNetFltRt-win.cpp
===================================================================
--- /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/drv/VBoxNetFltRt-win.cpp	(revision 63548)
+++ /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/drv/VBoxNetFltRt-win.cpp	(revision 63549)
@@ -15,4 +15,5 @@
  * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
+
 
 /*********************************************************************************************************************************
Index: /trunk/src/VBox/HostDrivers/VBoxUSB/win/dev/VBoxUsbRt.cpp
===================================================================
--- /trunk/src/VBox/HostDrivers/VBoxUSB/win/dev/VBoxUsbRt.cpp	(revision 63548)
+++ /trunk/src/VBox/HostDrivers/VBoxUSB/win/dev/VBoxUsbRt.cpp	(revision 63549)
@@ -16,4 +16,5 @@
  */
 
+
 /*********************************************************************************************************************************
 *   Header Files                                                                                                                 *
@@ -36,4 +37,5 @@
 
 #define VBOXUSB_MAGIC  0xABCF1423
+
 
 /*********************************************************************************************************************************
Index: /trunk/src/VBox/HostServices/SharedClipboard/VBoxClipboard-win.cpp
===================================================================
--- /trunk/src/VBox/HostServices/SharedClipboard/VBoxClipboard-win.cpp	(revision 63548)
+++ /trunk/src/VBox/HostServices/SharedClipboard/VBoxClipboard-win.cpp	(revision 63549)
@@ -41,4 +41,5 @@
 typedef BOOL WINAPI FNREMOVECLIPBOARDFORMATLISTENER(HWND);
 typedef FNREMOVECLIPBOARDFORMATLISTENER *PFNREMOVECLIPBOARDFORMATLISTENER;
+
 
 /*********************************************************************************************************************************
Index: /trunk/src/VBox/Main/src-server/win/svcmain.cpp
===================================================================
--- /trunk/src/VBox/Main/src-server/win/svcmain.cpp	(revision 63548)
+++ /trunk/src/VBox/Main/src-server/win/svcmain.cpp	(revision 63549)
@@ -174,5 +174,5 @@
     BOOL result = FALSE;
     typedef BOOL(WINAPI *PFNSHUTDOWNBLOCKREASONDESTROY)(HWND hWnd);
-    
+
     PFNSHUTDOWNBLOCKREASONDESTROY pfn = (PFNSHUTDOWNBLOCKREASONDESTROY)GetProcAddress(
         GetModuleHandle(L"User32.dll"), "ShutdownBlockReasonDestroy");
@@ -248,5 +248,5 @@
     wc.hbrBackground = (HBRUSH)(COLOR_BACKGROUND + 1);
     wc.lpszClassName = MAIN_WND_CLASS;
-    
+
 
     ATOM atomWindowClass = RegisterClass(&wc);
Index: /trunk/src/VBox/Runtime/r0drv/netbsd/alloc-r0drv-netbsd.c
===================================================================
--- /trunk/src/VBox/Runtime/r0drv/netbsd/alloc-r0drv-netbsd.c	(revision 63548)
+++ /trunk/src/VBox/Runtime/r0drv/netbsd/alloc-r0drv-netbsd.c	(revision 63549)
@@ -39,4 +39,5 @@
  * OTHER DEALINGS IN THE SOFTWARE.
  */
+
 
 /*********************************************************************************************************************************
Index: /trunk/src/VBox/Runtime/r0drv/netbsd/memobj-r0drv-netbsd.c
===================================================================
--- /trunk/src/VBox/Runtime/r0drv/netbsd/memobj-r0drv-netbsd.c	(revision 63548)
+++ /trunk/src/VBox/Runtime/r0drv/netbsd/memobj-r0drv-netbsd.c	(revision 63549)
@@ -3,4 +3,5 @@
  * IPRT - Ring-0 Memory Objects, NetBSD.
  */
+
 
 /*********************************************************************************************************************************
Index: /trunk/src/VBox/Runtime/r0drv/netbsd/semeventmulti-r0drv-netbsd.c
===================================================================
--- /trunk/src/VBox/Runtime/r0drv/netbsd/semeventmulti-r0drv-netbsd.c	(revision 63548)
+++ /trunk/src/VBox/Runtime/r0drv/netbsd/semeventmulti-r0drv-netbsd.c	(revision 63549)
@@ -64,4 +64,5 @@
 #define RTSEMEVENTMULTIBSD_STATE_GEN_INIT   UINT32_C(0xfffffffc)
 /** @}  */
+
 
 /*********************************************************************************************************************************
Index: /trunk/src/VBox/Runtime/r0drv/netbsd/spinlock-r0drv-netbsd.c
===================================================================
--- /trunk/src/VBox/Runtime/r0drv/netbsd/spinlock-r0drv-netbsd.c	(revision 63548)
+++ /trunk/src/VBox/Runtime/r0drv/netbsd/spinlock-r0drv-netbsd.c	(revision 63549)
@@ -28,4 +28,5 @@
  * OTHER DEALINGS IN THE SOFTWARE.
  */
+
 
 /*********************************************************************************************************************************
Index: /trunk/src/VBox/Runtime/r3/netbsd/rtProcInitExePath-netbsd.cpp
===================================================================
--- /trunk/src/VBox/Runtime/r3/netbsd/rtProcInitExePath-netbsd.cpp	(revision 63548)
+++ /trunk/src/VBox/Runtime/r3/netbsd/rtProcInitExePath-netbsd.cpp	(revision 63549)
@@ -25,7 +25,8 @@
  */
 
-/*******************************************************************************
-*   Header Files                                                               *
-*******************************************************************************/
+
+/*********************************************************************************************************************************
+*   Header Files                                                                                                                 *
+*********************************************************************************************************************************/
 #define LOG_GROUP RTLOGGROUP_PROCESS
 #include <sys/param.h>
Index: /trunk/src/VBox/Runtime/r3/posix/semmutex-posix.cpp
===================================================================
--- /trunk/src/VBox/Runtime/r3/posix/semmutex-posix.cpp	(revision 63548)
+++ /trunk/src/VBox/Runtime/r3/posix/semmutex-posix.cpp	(revision 63549)
@@ -99,5 +99,5 @@
             ts.tv_nsec = 0;
         }
-        
+
         nanosleep(&delta, &remaining);
 