Index: /trunk/src/VBox/HostDrivers/VBoxNetAdp/win/VBoxNetAdp-win.cpp
===================================================================
--- /trunk/src/VBox/HostDrivers/VBoxNetAdp/win/VBoxNetAdp-win.cpp	(revision 63563)
+++ /trunk/src/VBox/HostDrivers/VBoxNetAdp/win/VBoxNetAdp-win.cpp	(revision 63564)
@@ -197,5 +197,5 @@
         pAdapter->hAdapter = hAdapter;
         pAdapter->pGlobals = &g_VBoxNetAdpGlobals;
-        // TODO: Use netadp structure instead!
+        /// @todo Use netadp structure instead!
     /* Use a locally administered version of the OUI we use for the guest NICs. */
     pAdapter->MacAddr.au8[0] = 0x08 | 2;
@@ -207,5 +207,5 @@
     pAdapter->MacAddr.au8[5] = uIfIndex & 0xFF;
 
-        //TODO: Statistics?
+        /// @todo Statistics?
 
         *ppAdapter = pAdapter;
@@ -265,9 +265,9 @@
         }
 
-        // TODO: Registry?
-
-        // TODO: WDM stack?
-
-        // TODO: DPC?
+        /// @todo Registry?
+
+        /// @todo WDM stack?
+
+        /// @todo DPC?
 
         GAttrs.Header.Type = NDIS_OBJECT_TYPE_MINIPORT_ADAPTER_GENERAL_ATTRIBUTES;
@@ -277,5 +277,5 @@
         GAttrs.MediaType = NdisMedium802_3;
         GAttrs.PhysicalMediumType = NdisPhysicalMediumUnspecified;
-        GAttrs.MtuSize = 1500; //TODO
+        GAttrs.MtuSize = 1500; /// @todo
         GAttrs.MaxXmitLinkSpeed = VBOXNETADPWIN_LINK_SPEED;
         GAttrs.XmitLinkSpeed = VBOXNETADPWIN_LINK_SPEED;
@@ -284,8 +284,8 @@
         GAttrs.MediaConnectState = vboxNetAdpWinGetConnectState(pAdapter);
         GAttrs.MediaDuplexState = MediaDuplexStateFull;
-        GAttrs.LookaheadSize = 1500; //TODO
+        GAttrs.LookaheadSize = 1500; /// @todo
         GAttrs.MacOptions = VBOXNETADP_MAC_OPTIONS;
         GAttrs.SupportedPacketFilters = VBOXNETADP_SUPPORTED_FILTERS;
-        GAttrs.MaxMulticastListSize = 32; //TODO
+        GAttrs.MaxMulticastListSize = 32; /// @todo
 
         GAttrs.MacAddressLength = ETH_LENGTH_OF_ADDRESS;
@@ -334,5 +334,5 @@
     PVBOXNETADP_ADAPTER pAdapter = (PVBOXNETADP_ADAPTER)MiniportAdapterContext;
     LogFlow(("==>vboxNetAdpWinHaltEx\n"));
-    // TODO: Stop something?
+    /// @todo Stop something?
     if (pAdapter)
         vboxNetAdpWinFreeAdapter(pAdapter);
@@ -403,5 +403,5 @@
         case OID_GEN_RECEIVE_BUFFER_SPACE:
         case OID_GEN_TRANSMIT_BUFFER_SPACE:
-            // TODO: Make configurable
+            /// @todo Make configurable
             ulTmp = VBOXNETADP_MAX_FRAME_SIZE * 40;
             break;
@@ -418,5 +418,5 @@
             pStats->Header.Revision = NDIS_STATISTICS_INFO_REVISION_1;
             pStats->Header.Size = NDIS_SIZEOF_STATISTICS_INFO_REVISION_1;
-            // TODO: We need some stats, don't we?
+            /// @todo We need some stats, don't we?
             break;
         }
@@ -490,5 +490,5 @@
                 break;
             }
-            // TODO: For the time being we simply ignore lookahead settings.
+            /// @todo For the time being we simply ignore lookahead settings.
             pSet->BytesRead = sizeof(ULONG);
             Status = NDIS_STATUS_SUCCESS;
@@ -502,5 +502,5 @@
                 break;
             }
-            // TODO: For the time being we simply ignore packet filter settings.
+            /// @todo For the time being we simply ignore packet filter settings.
             pSet->BytesRead = pSet->InformationBufferLength;
             Status = NDIS_STATUS_SUCCESS;
Index: /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/cfg/VBoxNetCfg.cpp
===================================================================
--- /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/cfg/VBoxNetCfg.cpp	(revision 63563)
+++ /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/cfg/VBoxNetCfg.cpp	(revision 63564)
@@ -3286,5 +3286,5 @@
         hr = VBoxNetCfgWinQueryINetCfg(&pNetCfg, TRUE, L"VirtualBox Host-Only Creation",
                                        30 * 1000, /* on Vista we often get 6to4svc.dll holding the lock, wait for 30 sec.  */
-                                       /* TODO: special handling for 6to4svc.dll ???, i.e. several retrieves */
+                                       /** @todo special handling for 6to4svc.dll ???, i.e. several retrieves */
                                        &lpszApp);
         if (hr == S_OK)
Index: /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/drv/VBoxNetFltM-win.cpp
===================================================================
--- /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/drv/VBoxNetFltM-win.cpp	(revision 63563)
+++ /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/drv/VBoxNetFltM-win.cpp	(revision 63564)
@@ -384,5 +384,5 @@
     }
 
-    /* TODO: */
+    /** @todo */
     *OpenErrorStatus = Status;
 
@@ -710,5 +710,5 @@
 
             /* netflt is active, update the cached value */
-            /* TODO: in case we are are not in promiscuous now, we are issuing a request.
+            /** @todo in case we are are not in promiscuous now, we are issuing a request.
              * what should we do in case of a failure?
              * i.e. should we update the fUpperProtocolSetFilter in completion routine in this case? etc. */
Index: /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/drv/VBoxNetFltP-win.cpp
===================================================================
--- /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/drv/VBoxNetFltP-win.cpp	(revision 63563)
+++ /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/drv/VBoxNetFltP-win.cpp	(revision 63564)
@@ -588,5 +588,5 @@
 
 #if defined(DEBUG_NETFLT_PACKETS) || !defined(VBOX_LOOPBACK_USEFLAGS)
-    /* @todo: for optimization we could check only for netflt-mode packets
+    /** @todo for optimization we could check only for netflt-mode packets
      * do it for all for now */
      vboxNetFltWinLbRemoveSendPacket(pNetFlt, pPacket);
@@ -1310,5 +1310,5 @@
                     VBOXNETFLT_LBVERIFY(pNetFlt, pPacket);
 #ifdef DEBUG_misha
-                    /*TODO: remove this assert.
+                    /** @todo remove this assert.
                      * this is a temporary assert for debugging purposes:
                      * we're probably doing something wrong with the packets if the miniport reports NDIS_STATUS_RESOURCES */
Index: /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/drv/VBoxNetFltRt-win.cpp
===================================================================
--- /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/drv/VBoxNetFltRt-win.cpp	(revision 63563)
+++ /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/drv/VBoxNetFltRt-win.cpp	(revision 63564)
@@ -807,5 +807,5 @@
 #endif
 
-            /*TODO: FIXME: !!! the better approach for performance would be to dequeue all packets at once
+            /** @todo FIXME: !!! the better approach for performance would be to dequeue all packets at once
              * and then go through all dequeued packets
              * the same should be done for enqueue !!! */
@@ -974,5 +974,5 @@
         }
 
-        /* @todo: how would we fail in this case ?*/
+        /** @todo how would we fail in this case ?*/
     }
     return Status;
@@ -1194,5 +1194,5 @@
             {
                 AssertFailed();
-                /* TODO: what status to set? */
+                /** @todo what status to set? */
                 fStatus = NDIS_STATUS_FAILURE;
                 vboxNetFltWinMemFree(pSG);
@@ -1224,5 +1224,5 @@
             {
                 AssertFailed();
-                /* TODO: what status to set? */
+                /** @todo what status to set? */
                 fStatus = NDIS_STATUS_FAILURE;
                 break;
@@ -1297,5 +1297,5 @@
     if (status != NDIS_STATUS_SUCCESS)
     {
-        /* TODO */
+        /** @todo */
         AssertFailed();
     }
@@ -1345,5 +1345,5 @@
     if (status != NDIS_STATUS_SUCCESS)
     {
-        /* TODO */
+        /** @todo */
         AssertFailed();
         return false;
@@ -1372,5 +1372,5 @@
         if (fStatus != NDIS_STATUS_SUCCESS)
         {
-            /* TODO: */
+            /** @todo */
             AssertFailed();
             return fStatus;
@@ -1405,5 +1405,5 @@
             if (fStatus != NDIS_STATUS_SUCCESS)
             {
-                /* TODO */
+                /** @todo */
                 AssertFailed();
                 return fStatus;
@@ -1528,5 +1528,5 @@
         PVOID pvMemBuf;
 
-        /* @todo: generally we do not always need to zero-initialize the complete OOB data here, reinitialize only when/what we need,
+        /** @todo generally we do not always need to zero-initialize the complete OOB data here, reinitialize only when/what we need,
          * however we DO need to reset the status for the packets we indicate via NdisMIndicateReceivePacket to avoid packet loss
          * in case the status contains NDIS_STATUS_RESOURCES */
@@ -1586,5 +1586,5 @@
                     NdisGetPacketFlags(pPacket) = 0;
                 }
-                /* TODO: set out of bound data */
+                /** @todo set out of bound data */
             }
             else
@@ -1674,5 +1674,5 @@
     if (RT_FAILURE(rc))
     {
-        /* TODO: we can not prevent driver unload here */
+        /** @todo we can not prevent driver unload here */
         AssertFailed();
 
Index: /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/nobj/VBoxNetFltNobj.cpp
===================================================================
--- /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/nobj/VBoxNetFltNobj.cpp	(revision 63563)
+++ /trunk/src/VBox/HostDrivers/VBoxNetFlt/win/nobj/VBoxNetFltNobj.cpp	(revision 63564)
@@ -272,5 +272,5 @@
                 else
                 {
-                    /* TODO: we should check the default medium in HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Class\{4D36E972-E325-11CE-BFC1-08002bE10318}\<driver_id>\Ndi\Params\Medium, REG_SZ "Default" value */
+                    /** @todo we should check the default medium in HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Class\{4D36E972-E325-11CE-BFC1-08002bE10318}\<driver_id>\Ndi\Params\Medium, REG_SZ "Default" value */
                     NonStandardAssertBreakpoint();
                     *pbShouldBind = true;
Index: /trunk/src/VBox/HostDrivers/VBoxPci/linux/VBoxPci-linux.c
===================================================================
--- /trunk/src/VBox/HostDrivers/VBoxPci/linux/VBoxPci-linux.c	(revision 63563)
+++ /trunk/src/VBox/HostDrivers/VBoxPci/linux/VBoxPci-linux.c	(revision 63564)
@@ -221,5 +221,5 @@
         if (RT_LIKELY(pData->pIommuDomain))
         {
-            /** @todo: KVM checks IOMMU_CAP_CACHE_COHERENCY and sets
+            /** @todo KVM checks IOMMU_CAP_CACHE_COHERENCY and sets
              *  flag IOMMU_CACHE later used when mapping physical
              *  addresses, which could improve performance.
@@ -413,5 +413,5 @@
             return VERR_ACCESS_DENIED;
         }
-        /** @todo: RTStrCopy not exported. */
+        /** @todo RTStrCopy not exported. */
         strncpy(pIns->szPrevDriver, currentDriver, sizeof(pIns->szPrevDriver));
     }
@@ -1024,10 +1024,10 @@
             vbpci_printk(KERN_DEBUG, pIns->pPciDev, "PCIRAW_POWER_SUSPEND\n");
             rc = VINF_SUCCESS;
-            /// @todo: what do we do here?
+            /// @todo what do we do here?
             break;
         case PCIRAW_POWER_RESUME:
             vbpci_printk(KERN_DEBUG, pIns->pPciDev, "PCIRAW_POWER_RESUME\n");
             rc = VINF_SUCCESS;
-            /// @todo: what do we do here?
+            /// @todo what do we do here?
             break;
         default:
@@ -1061,5 +1061,5 @@
 
             flags = IOMMU_READ | IOMMU_WRITE;
-            /* @todo: flags |= IOMMU_CACHE; */
+            /** @todo flags |= IOMMU_CACHE; */
 
             r = iommu_map(domain, GuestStart, HostStart, get_order(cMemSize), flags);
Index: /trunk/src/VBox/HostDrivers/VBoxUSB/win/dev/VBoxUsbPnP.cpp
===================================================================
--- /trunk/src/VBox/HostDrivers/VBoxUSB/win/dev/VBoxUsbPnP.cpp	(revision 63563)
+++ /trunk/src/VBox/HostDrivers/VBoxUSB/win/dev/VBoxUsbPnP.cpp	(revision 63564)
@@ -182,5 +182,5 @@
     {
         AssertFailed();
-        /* todo: return more appropriate status ?? */
+        /** @todo return more appropriate status ?? */
         return STATUS_UNSUCCESSFUL;
     }
Index: /trunk/src/VBox/HostDrivers/VBoxUSB/win/dev/VBoxUsbRt.cpp
===================================================================
--- /trunk/src/VBox/HostDrivers/VBoxUSB/win/dev/VBoxUsbRt.cpp	(revision 63563)
+++ /trunk/src/VBox/HostDrivers/VBoxUSB/win/dev/VBoxUsbRt.cpp	(revision 63564)
@@ -1155,5 +1155,5 @@
                 break;
             case ((USBD_STATUS)0xC0010000L): // USBD_STATUS_CANCELED - too bad usbdi.h and usb.h aren't consistent!
-                // TODO: What the heck are we really supposed to do here?
+                /// @todo What the heck are we really supposed to do here?
                 pUrbInfo->error = USBSUP_XFER_STALL;
                 Status = STATUS_SUCCESS;